﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceTransformationExample
{
    class Camera
    {
        public Vector2 Position { get; set; }
        public float Rotation { get; set; }
        public float Zoom { get; set; }

        private SpriteBatch mSpriteBatch;

        public Camera(SpriteBatch sb)
        {
            mSpriteBatch = sb;
            Position = new Vector2(Game1.SCREEN_WIDTH/ 2, Game1.SCREEN_HEIGHT/ 2);
            Rotation = 0.0f;
            Zoom = 1.0f;
        }

        public void Begin()
        {
            mSpriteBatch.Begin();
        }

        public void End()
        {
            mSpriteBatch.End();
        }
        public void Draw(WorldObject obj)
        {


            //Vector2 objPosInScreenSpace = objPosInCameraSpace + new Vector2(Game1.SCREEN_WIDTH / 2, Game1.SCREEN_HEIGHT / 2);


            // TODO#1:  Modify the objPosInScreenSpace to handle moving the c amera left/right
            // TODO#2:  Modify the objPosInScreenSpace and objRotationInScreenSpace to handle rotating the camera
            // TODO#3:  Modify the objPosInSreenSpace and texture zoom (parameter in the draw method that has value 1.0f)
            //             to get zoom working correctly

            Vector2 objPosInCameraSpace = obj.PositionInWorldSpace;
            Vector2 objPosInScreenSpace = objPosInCameraSpace;
            float objRotationInScreenSpace = obj.RotationInWorldSpace;

            mSpriteBatch.Draw(obj.Texture, objPosInScreenSpace, null, Color.White, objRotationInScreenSpace, obj.TextureOrigin, 1.0f, SpriteEffects.None, 0);

        }
    }
}
